import es
from es import server_var
import time
import gamethread
import cmdlib
import playerlib
from configobj import ConfigObj
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Jumper"
info.version = "1.0"
info.url = "http://addons.eventscripts.com/addons/view/jumper"
info.basename = "jumper"
info.author = "chrismrulz"
es.set('jumper_version', info.version)
es.makepublic('jumper_version')

config = ConfigObj(es.server_var['eventscripts_gamedir'] + '/cfg/jumper.ini')
freezetime = int(config["Jumpers"]["freezetime"])
telemode = int(config["Jumpers"]["telemode"])
paladin_miss = config["Models"]["paladin_miss"]
paladin_hit = config["Models"]["paladin_hit"]
jumper_smoke = config["Models"]["jumper_smoke"]

def load():
	es.doblock('corelib/noisy_on')
	if(telemode != 1):
		if(es.exists('saycommand', '!tele') != 1):
			cmdlib.registerSayCommand('!tele', tele, 'Jumper teleport')
		if(es.exists('clientcommand', 'tele') != 1):
			cmdlib.registerClientCommand('tele', tele, 'Jumper teleport')

def unload():
	es.doblock('corelib/noisy_off')
	if(telemode != 1):
		cmdlib.unregisterSayCommand('!tele')
		cmdlib.unregisterClientCommand('tele')

def es_map_start(event_var):
	global model1
	global model2
	global model3
	model1 = es.precachemodel(paladin_miss)
	model2 = es.precachemodel(paladin_hit)
	model3 = es.precachemodel(jumper_smoke)

def player_spawn(event_var):
	if(event_var['es_userteam'] == 2):
		es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 400)
	elif(event_var['es_userteam'] == 3):
		es.setplayerprop(event_var['userid'], 'CBasePlayer.m_iHealth', 700)

def round_start(event_var):
	global ptimes
	ptimes = {}

def setptime(steamid, name, time):
	if(steamid not in ptimes):
		ptimes[steamid] = {}
		ptimes[steamid]['Name'] = name
		ptimes[steamid]['Time'] = time
	else:
		ptimes[steamid]['Time'] = time

def dojump(player):
	viewcoords = player.getViewCoord().split(',')
	viewcoords[2] = float(viewcoords[2]) + 100
	if(player.isObstructionBetween(viewcoords)):
		es.centertell(player.userid,"Can't teleport there.")
	else:
		loc = player.getLocation()
		player.setLocation(viewcoords)
		es.effect('smoke', "%s,%s,%s" % (loc[0], loc[1], loc[2]), model3, 400, 0.1)
		es.effect('smoke', "%s,%s,%s" % (viewcoords[0], viewcoords[1], viewcoords[2]), model3, 400, 0.1)

def jumper(player):
	hittime = int(time.time())
	if(player.steamid not in ptimes):
		dojump(player)
	elif(ptimes[player.steamid]['Time'] == 0):
		dojump(player)
	else:
		newhittime = hittime - ptimes[player.steamid][time]
		if(newhittime >= freezetime):
			dojump(player)

def paladin2(player):
	viewcoords = player.getViewCoord()
	loc = player.getLocation()
	es.effect('beam', viewcoords, "%s,%s,%s" % (loc[0], loc[1], loc[2]), model1, model1, 0, 0, 1, 3, 10, 0, 1, 255, 255, 255, 255, 30)

def paladin(player, attacker):
	player.freeze(1)
	gamethread.delayed(freezetime, unfreeze, player)
	hittime = int(time.time())
	if(player.steamid not in ptimes):
		setptime(player.steamid, player.name, hittime)
	else:
		if(ptimes[player.steamid]['Time'] == 0):
			setptime(player.steamid, player.name, hittime)
		else:
			newhittime = hittime - ptimes[player.steamid]['Time']
			if(newhittime > freezetime):
				setptime(player.steamid, player.name, hittime)
	loc = player.getLocation()
	loc2 = attacker.getLocation()
	es.effect('beam', "%s,%s,%s" % (loc[0], loc[1], loc[2]), "%s,%s,%s" % (loc2[0], loc2[1], loc2[2]), model2, model2, 0, 0, freezetime, 3, 10, 0, 1, 255, 255, 255, 255, 30)

def unfreeze(player):
	player.freeze(0)
	setptime(player.steamid, player.name, 0)

def player_hurt(event_var):
	if(event_var['es_attackerteam'] == '2'):
		paladin(playerlib.getPlayer(event_var['userid']), playerlib.getPlayer(event_var['attacker']))

def weapon_fire(event_var):
	if(event_var['es_userteam'] == '2'):
		paladin2(playerlib.getPlayer(int(event_var['userid'])))
	elif(event_var['es_userteam'] == '3' and event_var['weapon'] == 'knife' and telemode == 1):
		jumper(playerlib.getPlayer(int(event_var['userid'])))

def tele(userid, args):
	player = playerlib.getPlayer(userid)
	if(player.team == 3):
		jumper(player)